/* XulBulletinBoard.java */
package org.jxul.framework;

import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * Title:        JXul
 * Description:  Open Source project to interface Java and the
 * Java platform to the eXtensible User-interface Language (XUL).
 * Copyright:    Copyright (c) 2001
 * Company:      Open Source
 * @author Michael C. Daconta
 * @version 0.1
 *
 * A XUL BulletinBoard Widget
 */
public class XulBulletinBoard extends XulBox
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element bulletinBoardElement;
    int w = 100;
    int h = 100;
    
    public XulBulletinBoard(Element bulletinBoardElement, Hashtable peerMap) throws XulFormatException
    {
        super(bulletinBoardElement, peerMap);
        this.bulletinBoardElement = bulletinBoardElement;
    
    
        // Set layout to NULL - to allow X, Y positioning        
        setLayout(null);
        
        // TBD: special bb processing - not in Mozilla documentation yet
    
    } // end of XulBulletinBoard Constructor
    
    public Dimension getMinimumSize()
    {
        // check if the parent has a size?  
        /*
        Component c = this.getParent();
        if (c != null)
        {
            Dimension d = c.getSize();
            System.out.println("Parent's dim: " + d);
            if (d.width > 0 && d.height > 0)
                return d;
        }
        */
        return new Dimension(w,h);
    }
     
    public Dimension getPreferredSize()
    {
        return getMinimumSize();
    }
        
    public void paint(Graphics g)
    {
        System.out.println("Paint() in Bulletin Board");
        super.paint(g);
        
        Dimension d = getSize();
        System.out.println("Size of this component: " + d);
        
        // location of components
        Component [] carray = getComponents();
        System.out.println("# of components in this container: " + carray.length);
        for (int i=0; i < carray.length; i++)
        {
        	System.out.println("Painting component #" + i + 
        	   ",(x=" + carray[i].getLocation().x + ",y=" + 
        	   carray[i].getLocation().y);
            carray[i].paint(g);
        }
        
    }
        
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
