/* XulHTMLTextField.java */
package org.jxul.framework;

import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL HTML Text Field
 * Only grabbing child text.
 */
public class XulHTMLText extends JLabel
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element xulHTMLElement;

    public XulHTMLText(Element xulHTMLElement) throws XulFormatException
    {
        this.xulHTMLElement = xulHTMLElement;
	processChildren(xulHTMLElement);
    }
                  
    private void processChildren(Element node)
    {
        //go through them all & finally get text.
        Node childnode = node.getFirstChild();
        if (childnode != null)
        {
                switch (childnode.getNodeType())
                {
                        case Node.ELEMENT_NODE:
                                // if the first child is the element, then
                                // we will only pay attention to it. it
                                // can only be html formatting
                                if (debug)
                                        System.out.println("Skipping " + childnode.getNodeName());
                                processChildren((Element)childnode);
                        break;
                        case Node.TEXT_NODE:
                        case Node.CDATA_SECTION_NODE:
                                String val = childnode.getNodeValue();
                                if (val != null)
                                        setText(XmlUtil.normalizeSpaces(val));
                        break;
                }
        }
    }

    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}

