/* XulTree.java */
package org.jxul.framework;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.html.*;

import org.w3c.dom.*;

import org.jxul.util.*;
import org.jxul.framework.treetable.*;

/**
 * A XUL Iframe 
 */
public class XulIframe extends JPanel
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }

    private Element iframeElement;
    private JEditorPane html; 	
    // attributes
    String id;
    String src; 
    String style;
    Hashtable peerMap;

    public XulIframe(Element iframeElement) throws XulFormatException
    {
        this.iframeElement = iframeElement; 
	this.peerMap = peerMap;
	setLayout(new BorderLayout());

	/* TBD: Process These! */	
        Attr flexAttr = iframeElement.getAttributeNode(XulSyntax.ATTR_FLEX);
        Attr idAttr = iframeElement.getAttributeNode(XulSyntax.ATTR_ID);
        Attr srcAttr = iframeElement.getAttributeNode(XulSyntax.ATTR_SRC);
	
	//need to figure this one out
        if (srcAttr != null)
	{
		src = srcAttr.getNodeValue();
		try
		{
		  URL url = new URL(XulUtil.translateURL(src));
		  if (url != null)
		  {
			html = new JEditorPane(url);
			html.setEditable(false); 
			html.addHyperlinkListener(createHyperLinkListener());			
			//this seems to help it stay under control & not take over the whole application
			html.setPreferredSize(new Dimension(200,200));
			add(html);
	          }		
		  else
		  {
			System.out.println("**XulIframe - url was null: " + src);
		  }
		}
		catch (Exception e)
		{
			//e.printStackTrace();
			System.out.println("**XulIframe - Exception opening URL..");
		}
	}
	//do nothing I guess
	 
    } // end of XulTree Constructor
       
    public HyperlinkListener createHyperLinkListener() {
        return new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                    if (e instanceof HTMLFrameHyperlinkEvent) {
                        ((HTMLDocument)html.getDocument()).processHTMLFrameHyperlinkEvent(
                            (HTMLFrameHyperlinkEvent)e);
                    } else {
                        try {
                            html.setPage(e.getURL());
                        } catch (IOException ioe) {
                            System.out.println("IOE: " + ioe);
                        }
                    }
                }
            }
        };
    }       
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
