package org.jxul.framework;

/**
 * Encapsulation of the Xul Syntax to buffer the
 * code from changes.
 */
public class XulSyntax
{
    public static final String ELEMENT_WINDOW = "window";
    // window stuff
    public static final String WINDOW_ATTR_TITLE = "title";
    public static final String WINDOW_ATTR_TITLEMODIFIED = "titlemodified";
    public static final String WINDOW_ATTR_TITLEMENUSEPARATOR = "titlemenuseparator";
    public static final String WINDOW_ATTR_ID = "id";
    public static final String WINDOW_ATTR_XMLNS = "xmlns";
    public static final String WINDOW_ATTR_ONLOAD = "onload";
    public static final String WINDOW_ATTR_ONUNLOAD = "onunload";
    public static final String WINDOW_ATTR_WINDOWTYPE = "windowtype";
    public static final String WINDOW_ATTR_ALIGN = "align";

    public static final String WINDOW_ATTR_ALIGN_VERTICAL = "vertical";
    public static final String WINDOW_ATTR_ALIGN_HORIZONTAL = "horizontal";

    public static final String WINDOW_ATTR_WIDTH = "width";
    public static final String WINDOW_ATTR_HEIGHT = "height";
    public static final String WINDOW_ATTR_X = "x";
    public static final String WINDOW_ATTR_Y = "y";
    public static final String WINDOW_ATTR_PERSIST="persist";
    public static final String WINDOW_ATTR_ONDRAGGESTURE = "ondraggesture";

    public static final String ELEMENT_MENUBAR = "menubar";
    // menubar attributes
    public static final String MENUBAR_ATTR_CHROMECLASS = "chromeclass";
    public static final String MENUBAR_ATTR_CLASS = "class";
    public static final String MENUBAR_ATTR_ID = "id";
    public static final String MENUBAR_ATTR_FLEX = "flex";
    public static final String MENUBAR_ATTR_ALIGN = "align";
    public static final String MENUBAR_ATTR_ORIENT = "orient";
    public static final String MENUBAR_ATTR_AUTOSTRETCH = "autostretch";

    public static final String ELEMENT_MENU = "menu";
    // menu attributes
    public static final String MENU_ATTR_LABEL = "label";
    public static final String MENU_ATTR_FLEX = "flex";
    public static final String MENU_ATTR_KEY = "key";
    public static final String MENU_ATTR_DISABLED = "disabled";
    public static final String MENU_ATTR_ID = "id";
    public static final String MENU_ATTR_CLASS = "class";
    public static final String MENU_ATTR_ACCESSKEY = "accesskey";
    public static final String MENU_ATTR_ACCELTEXT = "acceltext";
    public static final String MENU_ATTR_CROP = "crop";
    public static final String MENU_ATTR_ORIENT = "orient";
    public static final String MENU_ATTR_AUTOSTRETCH = "autostretch";
    public static final String MENU_ATTR_ONCOMMAND = "oncommand";

    public static final String ELEMENT_MENUPOPUP = "menupopup";

    public static final String ELEMENT_MENUITEM = "menuitem";
    // menuitem attributes
    public static final String MENUITEM_ATTR_TYPE="type";
    public static final String MENUITEM_ATTR_TYPE_RADIO="radio";
    public static final String MENUITEM_ATTR_TYPE_CHECKBOX="checkbox";

    public static final String MENUITEM_ATTR_LABEL = "label";
    public static final String MENUITEM_ATTR_KEY = "key";

    public static final String MENUITEM_ATTR_DISABLED = "disabled";
    public static final String MENUITEM_ATTR_DISABLED_TRUE = "true";
    public static final String MENUITEM_ATTR_DISABLED_FALSE = "false";

    public static final String MENUITEM_ATTR_ID = "id";
    public static final String MENUITEM_ATTR_CLASS = "class";
    public static final String MENUITEM_ATTR_ACCESSKEY = "accesskey";
    public static final String MENUITEM_ATTR_ACCELTEXT = "acceltext";
    public static final String MENUITEM_ATTR_ONCOMMAND = "oncommand";
    public static final String MENUITEM_ATTR_OBSERVES = "observes";
    public static final String MENUITEM_ATTR_CHECKED = "checked";
    public static final String MENUITEM_ATTR_DATA = "data";
    public static final String MENUITEM_ATTR_NAME = "name";

    public static final String ELEMENT_MENUSEPARATOR = "menuseparator";

    public static final String ELEMENT_BOX = "box";

    public static final String BOX_ATTR_ALIGN = "align";
    public static final String BOX_ATTR_ALIGN_VERTICAL = "vertical";
    public static final String BOX_ATTR_ALIGN_HORIZONTAL = "horizontal";

    public static final String BOX_ATTR_STYLE = "style";
    public static final String BOX_ATTR_VALIGN = "valign";
    public static final String BOX_ATTR_CLASS = "class";
    public static final String BOX_ATTR_ID = "id";
    public static final String BOX_ATTR_FLEX = "flex";
    public static final String BOX_ATTR_WIDTH = "width";
    public static final String BOX_ATTR_HEIGHT = "height";
    public static final String BOX_ATTR_AUTOSTRETCH = "autostretch";
    public static final String BOX_ATTR_ORIENT = "orient";
    public static final String BOX_ATTR_ORIENT_VERTICAL = "vertical";
    public static final String BOX_ATTR_ORIENT_HORIZONTAL = "horizontal";
    public static final String BOX_ATTR_ONCOMMAND = "oncommand";

    public static final String ELEMENT_TITLE = "title";

    public static final String ELEMENT_GROUPBOX = "groupbox";
    public static final String ELEMENT_TITLEDBOX = "titledbox";
    public static final String TITLEDBOX_ATTR_LABEL = "label";

    public static final String ELEMENT_VBOX = "vbox";
    public static final String ELEMENT_HBOX = "hbox";

    public static final String ELEMENT_BUTTON = "button";
    public static final String BUTTON_ATTR_LABEL = "label";
    public static final String BUTTON_ATTR_CLASS = "class";
    public static final String BUTTON_ATTR_ONCLICK = "onclick";
    public static final String BUTTON_ATTR_ONCOMMAND = "oncommand";
    public static final String BUTTON_ATTR_ID = "id";
    public static final String BUTTON_ATTR_TOOLTIP = "tooltip";
    public static final String BUTTON_ATTR_DEFAULT = "default";
    public static final String BUTTON_ATTR_DISABLED = "disabled";
    public static final String BUTTON_ATTR_TOGGLED = "toggled";
    public static final String BUTTON_ATTR_SRC = "src";
    public static final String BUTTON_ATTR_CROP = "crop";

    public static final String ELEMENT_CHECKBOX = "checkbox";
    public static final String CHECKBOX_ATTR_LABEL = "label";
    public static final String CHECKBOX_ATTR_ACCESSKEY = "accesskey";
    public static final String CHECKBOX_ATTR_DISABLED = "disabled";
    public static final String CHECKBOX_ATTR_DISABLED_TRUE = "true";
    public static final String CHECKBOX_ATTR_DISABLED_FALSE = "false";

    public static final String CHECKBOX_ATTR_ONCOMMAND = "oncommand";
    public static final String CHECKBOX_ATTR_ID = "id";
    public static final String CHECKBOX_ATTR_CLASS = "class";
    public static final String CHECKBOX_ATTR_CHECKED = "checked";
    public static final String CHECKBOX_ATTR_CHECKED_TRUE = "true";
    public static final String CHECKBOX_ATTR_CHECKED_FALSE = "false";

    public static final String CHECKBOX_ATTR_CROP = "crop";
    public static final String CHECKBOX_ATTR_IMGALIGN = "imgalign";
    public static final String CHECKBOX_ATTR_SRC = "src";

    public static final String ELEMENT_RADIOGROUP = "radiogroup";
    public static final String RADIOGROUP_ATTR_ID = "id";
    public static final String RADIOGROUP_ATTR_ORIENT = "orient";
    public static final String RADIOGROUP_ATTR_ORIENT_VERTICAL = "vertical";
    public static final String RADIOGROUP_ATTR_ORIENT_HORIZONTAL = "horizontal";

    public static final String ELEMENT_RADIOBUTTON = "radio";
    public static final String RADIOBUTTON_ATTR_LABEL = "label";
    public static final String RADIOBUTTON_ATTR_ACCESSKEY = "accesskey";
    public static final String RADIOBUTTON_ATTR_DISABLED = "disabled";
    public static final String RADIOBUTTON_ATTR_DISABLED_TRUE = "true";
    public static final String RADIOBUTTON_ATTR_DISABLED_FALSE = "false";

    public static final String RADIOBUTTON_ATTR_ONCOMMAND = "oncommand";
    public static final String RADIOBUTTON_ATTR_ID = "id";
    public static final String RADIOBUTTON_ATTR_CLASS = "class";
    public static final String RADIOBUTTON_ATTR_CHECKED = "checked";
    public static final String RADIOBUTTON_ATTR_CHECKED_TRUE = "true";
    public static final String RADIOBUTTON_ATTR_CHECKED_FALSE = "false";

    public static final String RADIOBUTTON_ATTR_CROP = "crop";
    public static final String RADIOBUTTON_ATTR_IMGALIGN = "imgalign";
    public static final String RADIOBUTTON_ATTR_SRC = "src";

    //Replaced <text> tag for XUL 1.0
    public static final String ELEMENT_LABEL="label";

    public static final String ELEMENT_TEXT = "text";
    public static final String TEXT_ATTR_VALUE = "value";
    public static final String TEXT_ATTR_ID = "id";
    public static final String TEXT_ATTR_CLASS = "class";
    public static final String TEXT_ATTR_FOR = "for";

    public static final String ELEMENT_TABBOX = "tabbox";

    //updated tab syntax to XUL 1.0
    public static final String ELEMENT_TABS = "tabs";
    public static final String TABS_ATTR_ALIGN = "align";
    public static final String TABS_ATTR_ALIGN_VERTICAL = "vertical";
    public static final String TABS_ATTR_ALIGN_HORIZONTAL = "horizontal";

    public static final String TABS_ATTR_CLASS = "class";
    public static final String TABS_ATTR_FLEX = "flex";
    public static final String TABS_ATTR_ID = "id";
    public static final String TABS_ATTR_ORIENT = "orient";
    public static final String TABS_ATTR_AUTOSTRETCH = "autostretch";
    public static final String TABS_ATTR_ONCOMMAND = "oncommand";

    public static final String ELEMENT_TAB = "tab";
    public static final String TAB_ATTR_LABEL = "label";
    public static final String TAB_ATTR_STYLE = "style";
    public static final String TAB_ATTR_SELECTED = "selected";
    public static final String TAB_ATTR_ORIENT = "orient";
    public static final String TAB_ATTR_AUTOSTRETCH = "autostretch";
    public static final String TAB_ATTR_ONCOMMAND = "oncommand";

    public static final String ELEMENT_TABPANEL = "tabpanel";
    public static final String ELEMENT_TABPANELS = "tabpanels";
    public static final String TABPANELS_ATTR_ALIGN = "align";
    public static final String TABPANELS_ATTR_CLASS = "class";
    public static final String TABPANELS_ATTR_FLEX = "flex";
    public static final String TABPANELS_ATTR_ID = "id";
    public static final String TABPANELS_ATTR_ORIENT = "orient";
    public static final String TABPANELS_ATTR_AUTOSTRETCH = "autostretch";
    public static final String TABPANELS_ATTR_ONCOMMAND = "oncommand";

    public static final String ELEMENT_GRID = "grid";

    public static final String ELEMENT_ROWS = "rows";
    public static final String ELEMENT_COLUMNS = "columns";

    public static final String ELEMENT_ROW = "row";
    public static final String ELEMENT_COLUMN = "column";

    public static final String ELEMENT_TOOLBOX = "toolbox";
    public static final String ELEMENT_TOOLBAR = "toolbar";
    public static final String TOOLBOX_ATTR_ID = "id";
    public static final String TOOLBOX_ATTR_CLASS = "class";
    public static final String TOOLBOX_ATTR_AUTOSTRETCH="autostretch";
    public static final String TOOLBOX_ATTR_ORIENT = "orient";
    public static final String TOOLBOX_ATTR_ORIENT_VERTICAL="vertical";
    public static final String TOOLBOX_ATTR_ORIENT_HORIZONTAL="horizontal";
    public static final String TOOLBOX_ATTR_STYLE="style";

    public static final String TOOLBAR_ATTR_CLASS="class";
    public static final String TOOLBAR_ATTR_ID="id";
    public static final String TOOLBAR_ATTR_CHROMECLASS="chromeclass";
    public static final String TOOLBAR_ATTR_PERSIST="persist";
    public static final String TOOLBAR_ATTR_DRAGDROPAREA="dragdroparea";
    public static final String TOOLBAR_ATTR_ONDRAGGESTURE="ondraggesture";
    public static final String TOOLBAR_ATTR_ONDRAGDROP="ondragdrop";
    public static final String TOOLBAR_ATTR_ONDRAGOVER="ondragover";
    public static final String TOOLBAR_ATTR_ONDRAGEXIT="ondragexit";
    public static final String TOOLBAR_ATTR_TOOLTIP="tooltip";
    public static final String TOOLBAR_ATTR_ORIENT="orient";
    public static final String TOOLBAR_ATTR_ORIENT_VERTICAL="vertical";
    public static final String TOOLBAR_ATTR_ORIENT_HORIZONTAL="horizontal";

    public static final String TOOLBAR_ATTR_AUTOSTRETCH="autostretch";

    public static final String ELEMENT_IMAGE = "image";
    public static final String IMAGE_ATTR_SRC = "src";
    public static final String IMAGE_ATTR_ID = "id";
    public static final String IMAGE_ATTR_CLASS = "class";
    public static final String IMAGE_ATTR_ONCLICK = "onclick";

    public static final String ELEMENT_STACK = "stack";

    public static final String ELEMENT_SCRIPT = "SCRIPT";

    public static final String ELEMENT_HTMLSCRIPT = "HTML:SCRIPT";

    public static final String ELEMENT_BULLETIN_BOARD = "bulletinboard";

    //XUL 1.0 -> TEXTBOX replaces TEXTFIELD
    public static final String ELEMENT_TEXTBOX = "textbox";
    public static final String ELEMENT_TEXTFIELD = "textfield";
    public static final String TEXTFIELD_ATTR_VALUE = "value";
    public static final String TEXTFIELD_ATTR_ID = "id";
    public static final String TEXTFIELD_ATTR_CLASS = "class";
    public static final String TEXTFIELD_ATTR_MULTILINE = "multiline";
    public static final String TEXTFIELD_ATTR_WIDTH = "width";
    public static final String TEXTFIELD_ATTR_FLEX = "flex";
    public static final String TEXTFIELD_ATTR_MAXLENGTH = "maxlength";

    // trees
    public static final String ELEMENT_TREE = "tree";
    public static final String ELEMENT_TREECOLGROUP = "treecolgroup";
    public static final String TREE_ATTR_ONSELECT="onselect";
    public static final String ELEMENT_TREECELL = "treecell";
    public static final String TREECELL_CLASS_INDENT_VALUE="treecell-indent";

    public static final String ELEMENT_TREECHILDREN = "treechildren";
    public static final String ELEMENT_TREEHEAD = "treehead";
    public static final String ELEMENT_TREEITEM = "treeitem";
    public static final String TREEITEM_ATTR_CONTAINER = "container";
    public static final String TREEITEM_ATTR_OPEN = "open";
    public static final String TREEITEM_ATTR_HIDDEN = "hidden";

    public static final String ELEMENT_TREEROW ="treerow";

    public static final String ELEMENT_OVERLAY="overlay";
    public static final String ELEMENT_IFRAME="iframe";
    public static final String ELEMENT_HTMLIFRAME="html:iframe";

    /*
     * maybe we should stick to these, since everything inherits
     * from XulElement in the real code
     */
    public static final String ATTR_ID = "id";
    public static final String ATTR_CLASS = "class";
    public static final String ATTR_FLEX = "flex";
    public static final String ATTR_ALIGN="align";
    public static final String ALIGN_HORIZONTAL = "horizontal";
    public static final String ALIGN_VERTICAL = "vertical";
    public static final String ALIGN_CENTER = "center";
    public static final String ATTR_ORIENT="orient";
    public static final String ATTR_LABEL="label";
    public static final String ATTR_STYLE="style";
    public static final String ATTR_SRC="src";

	// Added by Seor Vaughn - 8 JUL 2001
	// For ProgressMeter to JProgressBar Syntax Conversion

	public static final String ELEMENT_PROGRESSMETER 			= "progressmeter";
	public static final String PROGRESSMETER_ATTR_VALUE			= "value";

    /*
value
id
class
multiline
width
flex
maxlength
*/

}
