/* XulTab.java */
package org.jxul.framework;

import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL Tab Box. 
 */
public class XulTab extends JPanel
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element tabElement;
    // attributes
    String label;
    String style;
    String selected;
    String orient;
    String autostretch;
    String oncommand;

    public String getValue() { return label; }

    public XulTab(Element tabElement) throws XulFormatException
    {
        this.tabElement = tabElement; 

        Attr labelAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_LABEL);
        if (labelAttr != null)
        {
            label = labelAttr.getNodeValue();
        }

        Attr styleAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_STYLE);
        Attr selectedAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_SELECTED);
	if (selectedAttr != null)
	{
		selected = selectedAttr.getNodeValue(); 	
	}
        Attr orientAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_ORIENT);
        Attr autostretchAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_AUTOSTRETCH);
        Attr oncommandAttr = tabElement.getAttributeNode(XulSyntax.TAB_ATTR_ONCOMMAND);
    } // end of XulTitledBox Constructor

    public boolean isSelected()
    {
	return (selected != null && selected.equalsIgnoreCase("TRUE"));
    }
                   
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
