package org.jxul.framework;

import javax.swing.*;
import javax.swing.text.*;

import org.w3c.dom.*;

/**
 * Title:        JXul
 * Description:  Open Source project to interface Java and the
 * Java platform to the eXtensible User-interface Language (XUL).
 * Copyright:    Copyright (c) 2000
 * Company:      Open Source
 * @author Michael Daconta
 * @version 1.0
 */
public class XulTextField
{
    static org.w3c.dom.Element textFieldElement;
    static String style;
    static String value;
    static String _class;
    static String id;
    static boolean multiline;
    static String width;
    static String flex;
    static String maxlength;

    static Attr valueAttr;
    static Attr _classAttr;
    static Attr idAttr;
    static Attr multilineAttr;
    static Attr widthAttr;
    static Attr flexAttr;
    static Attr maxlengthAttr;

    public static JComponent getTextField(org.w3c.dom.Element textFieldElement)
    {
        JComponent comp = null;

        textFieldElement = textFieldElement;

        // TBD: process all attributes

        Attr valueAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_VALUE);
        if (valueAttr != null)
        {
            value = valueAttr.getNodeValue();
        }

        Attr _classAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_CLASS);
        Attr idAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_ID);

        Attr multilineAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_MULTILINE);
        if (multilineAttr != null)
        {
            String sMulti = multilineAttr.getNodeValue();
            if (sMulti != null)
            {
                if (sMulti.equalsIgnoreCase("true"))
                {
                    multiline = true;
                }
            }
        }

        Attr widthAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_WIDTH);
        Attr flexAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_FLEX);
        Attr maxlengthAttr = textFieldElement.getAttributeNode(XulSyntax.TEXTFIELD_ATTR_MAXLENGTH);

        if (multiline)
        {
            if (value != null)
               comp = new JScrollPane(new JTextArea(value));
            else
                comp = new JScrollPane(new JTextArea());
        }
        else
        {
            if (value != null)
               comp = new JTextField(value);
            else
                comp = new JTextField();
        }

        return comp;
    }

    /** A factory method only. */
    private XulTextField()
    { }

}
