package org.jxul.util;

import java.util.*;

import org.w3c.dom.*;

public class DomUtil
{
    public static void normalizeDocument(Node n)
    {
        if (!n.hasChildNodes())
            return;
            
        NodeList nl = n.getChildNodes();
        for (int i = 0; i < nl.getLength(); i++)
        {
            Node cn = nl.item(i);
            if (cn.getNodeType() == Node.TEXT_NODE &&
                StringUtil.isBlank(cn.getNodeValue()))
            {
                n.removeChild(cn);
                i--;
            }
            else    
                normalizeDocument(cn);
        }                
    }
    
    public static Element getNextSiblingElement (Element elem) 
    {
        for (Node n = elem.getNextSibling (); n != null; n = n.getNextSibling ()) 
        {
            if (n.getNodeType () == Node.ELEMENT_NODE) 
            return (Element) n;
        }
        return null;
    }
    
    

    /** original method findChildElementWithAttribute was from
        apache code.  Modified here to be a recursive search.
        Thus the name change. */
    public static Element findElementWithAttribute(Element elem, 
                                                    String attrName,
                                                    String attrValue)   
    {
        Element result = null;
        for (Node n = elem.getFirstChild (); n != null; n = n.getNextSibling ()) 
        {
            if (n.hasChildNodes())
                result = findElementWithAttribute((Element) n, attrName, attrValue);
            
            if (result != null) 
                return result;
                
            if (n.getNodeType () == Node.ELEMENT_NODE) 
            {
                if (attrValue.equals (DOMUtils.getAttribute ((Element) n, attrName))) 
                    return (Element) n;
        }
    }
    return  null;
  }
    
}