/* Main.java */
package org.jxul.xulrunner;

import java.io.*;

import javax.xml.parsers.*;
import org.w3c.dom.*;

/**
 * Launch point for XulRunner.
 */
public class Main
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    public static void main(String args[])
    {
        if (args.length < 1)
        {
            System.out.println("USAGE: java org.jxul.xulrunner.Main xulInputFile [-console]");
            System.exit(1);
        }
        
        try
        {
            String curDir = System.getProperty("user.dir");
            
            String inputFile = args[0];
            File f = new File(inputFile);

            // TBD: check for -console 
            // -console option will launch a separate console 
            // app that will assist in configuration,  running and 
            // debugging of standalone XulApplications
            
            if (f.exists())
            {
                // ensure document is well-formed
                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                DocumentBuilder dbldr = factory.newDocumentBuilder();
		
		//note that we need to do something when there are chrome: references
                //in the DTD
                Document doc = dbldr.parse(new File(inputFile));

                // assemble the XulApplication
                XulApplication xulApp = new XulApplication(doc);
                
                // start it
                xulApp.start();
            }
            else
                System.out.println("File: " + args[0] + " does not exist. Aborting.");
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
